package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class CaseUpdateSuperviseModelImpl implements ICaseUpdateSuperviseModel {

    private OnUpdateSuperviseListener listener;

    public CaseUpdateSuperviseModelImpl(OnUpdateSuperviseListener updateSuperviseListener) {
        this.listener = updateSuperviseListener;
    }

    /**
     * 数据回调接口
     */
    public interface OnUpdateSuperviseListener {
        void onSuccess(ActionResultBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest(String id, String superviseRemarks) {
        Observable<ActionResultBean> observable = RetrofitServiceManager.getUpdateSuperviseResult(id, superviseRemarks);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<ActionResultBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(ActionResultBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}